package com.supwisdom.dlpay.consume.service.impl

import com.supwisdom.dlpay.consume.PersonTransBuilder
import com.supwisdom.dlpay.consume.dao.AccountDao
import com.supwisdom.dlpay.consume.domain.TAccount
import com.supwisdom.dlpay.consume.domain.TPaydtl
import com.supwisdom.dlpay.consume.service.AccountUtilServcie
import com.supwisdom.dlpay.consume.service.PersonBalancePayService
import com.supwisdom.dlpay.exception.TransactionProcessException
import com.supwisdom.dlpay.framework.dao.PaydtlDao
import com.supwisdom.dlpay.framework.domain.TShopacc
import com.supwisdom.dlpay.framework.domain.TSubject
import com.supwisdom.dlpay.framework.domain.TTranstype
import com.supwisdom.dlpay.framework.util.TradeErrorCode
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service
import javax.persistence.EntityManager
import javax.persistence.PersistenceContext


@Service
class AccountUtilServcieImpl : AccountUtilServcie {

    override fun readAccountForUpdate(userid: String, nowait: Boolean): TAccount {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readAccount(userid: String): TAccount {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readShopAccForUpdate(shopId: String, nowait: Boolean): TShopacc {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readShopAcc(shopId: String): TShopacc {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readSubjectForUpdate(subjno: String, nowait: Boolean): TSubject {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readSubject(subjno: String): TSubject {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun readTranstype(transtype: Int): TTranstype {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }
}

@Service
class PersonBalancePayServiceImpl : PersonBalancePayService {
    @Autowired
    lateinit var paydtlDao: PaydtlDao

    @Autowired
    lateinit var accountDao: AccountDao

    @PersistenceContext
    lateinit var em: EntityManager

    private fun lockAccount(builder: PersonTransBuilder): TAccount {
        TODO("")
    }

    override fun process(builder: PersonTransBuilder): TPaydtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun init(builder: PersonTransBuilder): TPaydtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun wip(paydtl: TPaydtl, builder: PersonTransBuilder): TPaydtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun wip(refno: String, builder: PersonTransBuilder): TPaydtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun finish(paydtl: TPaydtl, status: String, builder: PersonTransBuilder): TPaydtl {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun finish(refno: String, status: String, builder: PersonTransBuilder): TPaydtl {
        paydtlDao.findById(refno).let {
            if (it.isPresent) {
                return finish(it.get(), status, builder)
            }
            throw TransactionProcessException(TradeErrorCode.TRANSACTION_NOT_EXISTS, "交易参考号<$refno>不存在")
        }
    }


}